#include "mainwindow.h"
#include "ui_mainwindow.h"
#include <QDir>
#include <QFileInfo>
#include <QToolBar>
#include <QSplitter>
#include <QDrag>
#include <QMimeData>
#include <QDragEnterEvent>

class MyButton : public QToolButton
{
   protected:
       virtual void dragEnterEvent ( QDragEnterEvent * event );
       virtual void dropEvent ( QDropEvent * event );
};

void MyButton::dragEnterEvent ( QDragEnterEvent * event )
{
    event->acceptProposedAction();
}

void MyButton::dropEvent ( QDropEvent * event )
{

}

void MainWindow::on_sourceButton_pressed()
{
    QDrag * drag = new QDrag (ui->sourceButton);
    QMimeData * mime = new QMimeData;
    mime->setText("hello");
    mime->setImageData(ui->sourceButton->icon());
    drag->setMimeData(mime);
    drag->exec(Qt::DropActions (Qt::CopyAction | Qt::MoveAction | Qt::LinkAction));

}

void MainWindow::showDir (QString path, QTreeWidgetItem * target)
{
   QDir dir (path);
   QFileInfoList list = dir.entryInfoList
        (QDir::Dirs | QDir::Files | QDir::NoDotAndDotDot, QDir::Name);

   foreach (QFileInfo info, list)
   {
     QTreeWidgetItem * item = new QTreeWidgetItem;
     item->setText (0, info.fileName());
     item->setToolTip (0, info.filePath());

     if (info.suffix() == "png")
     {
        QIcon icon (info.filePath());
        item->setIcon (0, icon);
     }

     if (target == NULL)
         ui->treeWidget->addTopLevelItem(item);
     else
         target->addChild(item);

     if (info.isDir())
         showDir (info.filePath(), item);
   }
}


MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);

    // showDir ("../images", NULL);
    showDir ("/usr/share/icons", NULL);

    QSplitter * s = new QSplitter(Qt::Vertical);
    setCentralWidget(s);

    ui->targetButton = new MyButton;

    s->addWidget (ui->tabWidget);
    s->addWidget (ui->treeWidget);
    s->addWidget (ui->sourceButton);
    s->addWidget (ui->targetButton);


    // ui->tabWidget->clear();
    QToolBar * bar = new QToolBar;
    ui->tabWidget->addTab (bar, "images");

    QDir dir ("../images");
    QStringList filter ("*.png");
    QFileInfoList list = dir.entryInfoList(filter, QDir::Files, QDir::Name);
    foreach (QFileInfo info, list)
    {
        QToolButton * b = new QToolButton;
        b->setText(info.fileName());
        b->setToolTip(info.fileName());
        QIcon icon (info.filePath());
        b->setIcon(icon);
        bar->addWidget (b);
    }


    QIcon icon ("../images/open.png");
    ui->sourceButton->setIcon (icon);


    ui->targetButton->setAcceptDrops(true);
}

MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::on_sourceButton_clicked()
{

}

// #include <QDrag>
// #include <QMimeData>

